package com.cf.imes.module.executor.service.moduleitem;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.cf.imes.module.executor.controller.admin.moduleitem.vo.*;
import com.cf.imes.module.executor.dal.dataobject.moduleitem.ModuleItemDO;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.common.pojo.PageParam;
import com.cf.imes.framework.common.util.object.BeanUtils;

import com.cf.imes.module.executor.dal.mysql.moduleitem.ModuleItemMapper;

import static com.cf.imes.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.cf.imes.module.executor.enums.ErrorCodeConstants.*;

/**
 * 生产单模块明细 Service 实现类
 *
 * @author 晨丰科技
 */
@Service
@Validated
public class ModuleItemServiceImpl implements ModuleItemService {

    @Resource
    private ModuleItemMapper moduleItemMapper;

    @Override
    public Long createModuleItem(ModuleItemSaveReqVO createReqVO) {
        // 插入
        ModuleItemDO moduleItem = BeanUtils.toBean(createReqVO, ModuleItemDO.class);
        moduleItemMapper.insert(moduleItem);
        // 返回
        return moduleItem.getId();
    }

    @Override
    public void updateModuleItem(ModuleItemSaveReqVO updateReqVO) {
        // 校验存在
        validateModuleItemExists(updateReqVO.getId());
        // 更新
        ModuleItemDO updateObj = BeanUtils.toBean(updateReqVO, ModuleItemDO.class);
        moduleItemMapper.updateById(updateObj);
    }

    @Override
    public void deleteModuleItem(Long id) {
        // 校验存在
        validateModuleItemExists(id);
        // 删除
        moduleItemMapper.deleteById(id);
    }

    private void validateModuleItemExists(Long id) {
        if (moduleItemMapper.selectById(id) == null) {
            throw exception(MODULE_ITEM_NOT_EXISTS);
        }
    }

    @Override
    public ModuleItemDO getModuleItem(Long id) {
        return moduleItemMapper.selectById(id);
    }

    @Override
    public PageResult<ModuleItemDO> getModuleItemPage(ModuleItemPageReqVO pageReqVO) {
        return moduleItemMapper.selectPage(pageReqVO);
    }

}